<template>
  <v-container>
    <v-row>
      <v-col>
        <v-btn
          depressed
          small
          color="green"
          class="toStock-reservedProduct mr-2"
          @click="showAllStates"
        >Enseña todo</v-btn>
        <v-btn
          depressed
          small
          color="orange"
          class="toStock-reservedProduct mr-2"
          @click="showEditAwaitProductsState"
        >En Espera</v-btn>
        <v-btn
          depressed
          small
          color="green"
          class="toStock-reservedProduct mr-2"
          @click="showEditConfirmedProductsState"
        >Confirmados</v-btn>
        <v-btn
          depressed
          small
          color="orange"
          class="toStock-reservedProduct mr-2"
          @click="showEditreservedProductsState"
        >Reservados</v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12" sm="6" md="3" v-for="(awaitProduct, index) in awaitProducts" :key="index">
        <EditAwaitProductsState
          v-show="awaitHas"
          :awaitProduct="awaitProduct"
          :actualUserRole="actualUserRole"
          @go-to-messages="goToMessages"
          @go-to-user-profil="goToThisUserProfil"
          @confirm-awaitProduct-event="changeProductStateToConfirmed"
          @reject-awaitProduct-event="changeProductStateToRejected"
          @go-to-edit-product="goToEditProduct"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col
        cols="12"
        sm="6"
        md="3"
        v-for="(confirmedProduct, index) in confirmedProducts"
        :key="index"
      >
        <EditConfirmedProductsState
          v-show="confirmedHas"
          :confirmedProduct="confirmedProduct"
          :actualUserRole="actualUserRole"
          @to-stock-confirmedProduct-event="
          changeConfirmedProductStateToDisponible
        "
          @reject-confirmedProduct-event="changeProductStateToRejected"
          @go-to-edit-product="goToEditProduct"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col
        cols="12"
        sm="6"
        md="3"
        v-for="(reservedProduct, index) in reservedProducts"
        :key="index"
      >
        <EditreservedProductsState
          v-show="reservedHas"
          :reservedProduct="reservedProduct"
          :actualUserRole="actualUserRole"
          @go-to-messages="goToMessages"
          @go-to-user-profil="goToThisUserProfil"
          @to-stock-reservedProduct-event="changeProductStateToDisponible"
          @to-selled-reservedProduct-event="changeProductStateToSold"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import EditAwaitProductsState from './EditAwaitProductsState.vue'
import EditConfirmedProductsState from './EditConfirmedProductsState.vue'
import EditreservedProductsState from './EditreservedProductsState.vue'

import API from '@/API.js'

export default {
  name: 'ProductsManagementPage',
  components: {
    EditAwaitProductsState,
    EditConfirmedProductsState,
    EditreservedProductsState
  },
  props: {
    idActualUser: String,
    actualUserRole: String
  },

  data() {
    return {
      awaitHas: true,
      confirmedHas: true,
      reservedHas: true,
      awaitProducts: null,
      rejectedProducts: null,
      confirmedProducts: null,
      reservedProducts: null
    }
  },

  async mounted() {
    this.getProductsLists()
  },

  methods: {
    async getProductsLists() {
      this.awaitProducts = await API.loadProductsEnAwait()
      this.rejectedProducts = await API.loadRejectedProducts()
      this.confirmedProducts = await API.loadConfirmedProducts()
      this.reservedProducts = await API.loadReservedProducts()
    },

    showEditAwaitProductsState() {
      this.awaitHas = true
      this.confirmedHas = false
      this.reservedHas = false
    },
    showEditConfirmedProductsState() {
      this.awaitHas = false
      this.confirmedHas = true
      this.reservedHas = false
    },
    showEditreservedProductsState() {
      this.awaitHas = false
      this.confirmedHas = false
      this.reservedHas = true
    },
    showAllStates() {
      this.awaitHas = true
      this.confirmedHas = true
      this.reservedHas = true
    },

    async changeConfirmedProductStateToDisponible(idproduct) {
      await API.changeConfirmedProductStateToDisponible(idproduct)
      this.getProductsLists()
    },

    async changeProductStateToConfirmed(idproduct) {
      await API.changeProductStateToConfirmed(idproduct)
      this.getProductsLists()
    },
    async changeProductStateToRejected(idproduct) {
      await API.changeProductStateToRejected(idproduct)
      this.getProductsLists()
    },

    async changeProductStateToDisponible(idproduct, idReservatiopn, promos) {
      if (promos === '0') {
        await this.changeNormalProductStateToDisponible(
          idproduct,
          idReservatiopn,
          this.idActualUser
        )
      } else {
        await this.changePromoProductStateToDisponible(
          idproduct,
          idReservatiopn,
          this.idActualUser
        )
      }
    },

    async changeNormalProductStateToDisponible(idproduct, idReservatiopn) {
      await API.changeProductStateToDisponible(
        idproduct,
        idReservatiopn,
        this.idActualUser
      )
      this.getProductsLists()
    },
    async changePromoProductStateToDisponible(idproduct, idReservatiopn) {
      await API.changePromoProductStateToDisponible(
        idproduct,
        idReservatiopn,
        this.idActualUser
      )
      this.getProductsLists()
    },

    async changeProductStateToSold(idproduct, idReservatiopn) {
      await API.changeProductStateToSold(
        idproduct,
        idReservatiopn,
        this.idActualUser
      )
      this.getProductsLists()
    },
    goToEditProduct(idproduct) {
      this.$router.push(
        '/edit-product-detail/' + this.idActualUser + '/' + idproduct
      )
    },
    goToMessages(id_user) {
      this.$router.push('/MessengerPage/' + this.idActualUser + '/' + id_user)
    },
    goToThisUserProfil(id_user) {
      this.$router.push('/user-profile/' + this.idActualUser + '/' + id_user)
    }
  }
}
</script>

<style scoped>
/* .grid {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(200px, 1fr));
  row-gap: 0rem;
  column-gap: 0rem;
  place-items: center;
}

.grid > div {
  padding: 1rem;
  display: grid;
  place-items: center;
}
.grid > div::before {
  content: '';
  padding-top: 100%;
  display: block;
  grid-area: 1 / 1 / 2 / 2;
}
.button-product-management {
  display: flex;

  justify-content: space-around;
}

body {
  margin: 2rem;
} */
</style>
